<?php

if(!defined('IN_MYBB')){
	die('Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.');
}

function xtdispportal_info(){
	return array(
		'name'			=> 'Selected Threads Title On Portal',
		'description'	=> 'Displaying selected threads title on portal',
		'website'		=> 'http://mybbhacks.zingaburga.com',
		'author'		=> 'XThreads Mania',
		'authorsite'	=> 'http://mybbhacks.zingaburga.com',
		'version'		=> '1.1',
		'compatibility' => '1*',
		'guid'        	=> ''
	);
}

function xtdispportal_activate(){
	if(!function_exists('xthreads_gettfcache')){
		global $mybb;
		$sep = $mybb->version_code >= 1500 ? '-':'/';
		flash_message('This plugin required XThreads to be installed or actived', 'error');
		admin_redirect('index.php?module=config'.$sep.'plugins');
	}
	global $db;
	$db->insert_query('templates', array(
		'title'		=> 'xtdispportal_threads',
		'template'	=> $db->escape_string('<table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder">
	<tr>
		<td class="thead">
			<strong>{$xtdispportal_threads_num} Featured Threads</strong>
		</td>
	</tr>
	{$xtdispportal_threads_thread}
</table>'),
		'sid'		=> -1
	));
	$db->insert_query('templates', array(
		'title'		=> 'xtdispportal_threads_thread',
		'template'	=> $db->escape_string('<tr>
	<td class="{$altbg}">
		<div>
			{$xtdispportal_thread_icon}
			<strong><a href="{$xtdispportal_thread_link}">{$xtdispportal_thread_subject}</a></strong>
			By: {$xtdispportal_profile_link}
		</div>
		<br class="clear" />
		<div class="post_body">
			{$xtdispportal_postpreview}
		</div>
		<div class="smalltext">
			<em>Posted In: <a href="{$xtdispportal_forum_link}">{$xtdispportal_forum_name}</a>,
			{$xtdispportal_date} at {$xtdispportal_time}<br />
			Replies: {$xtdispportal_replies}, Views: {$xtdispportal_views}</em>
		</div>
	</td>
</tr>'),
		'sid'		=> -1
	));
}

function xtdispportal_deactivate(){
	global $db;
	$db->delete_query('templates', 'title IN("xtdispportal_threads", "xtdispportal_threads_thread")');
}

$plugins->add_hook('xthreads_uninstall_end', 'xtdispportal_xtdu');
$plugins->add_hook('xthreads_deactivate_end', 'xtdispportal_xtdu');
function xtdispportal_xtdu(){
	global $active_plugins;
	xtdispportal_deactivate();
	unset($active_plugins['xtdispportal']);
}

$plugins->add_hook('global_start', 'xtdispportal_tcache');
function xtdispportal_tcache(){
	if(THIS_SCRIPT == 'portal.php'){
		global $templatelist;
		if(isset($templatelist)){
			$templatelist .= ',xtdispportal_threads,xtdispportal_threads_thread';
		}
	}
}

$plugins->add_hook('portal_start', 'xtdispportal_run');
function xtdispportal_run(){
	$xtdpf = xthreads_gettfcache();
	if(!empty($xtdpf) && is_array($xtdpf['xtdispportal'])){
		global $db, $cache;
		$xtdpf_fid_in = '';
		if($xtdpf['xtdispportal']['forums']){
			$xtdpf_fids = explode(',',$xtdpf['xtdispportal']['forums']);
			if(is_array($xtdpf_fids)){
				foreach($xtdpf_fids as $xtdpffid){
					$xtdpffids[] = intval($xtdpffid);
				}
				$xtdpf_fid = implode(',',$xtdpffids);
				$xtdpf_fid_in = 't.fid IN ('.$xtdpf_fid.') AND ';
			}
		}
		$xtdispportal_unviewable = get_unviewable_forums(true);
		if($xtdispportal_unviewable){
			$xtdispportal_unviewwhere = ' AND t.fid NOT IN ('.$xtdispportal_unviewable.')';
		}
		$altbg = alt_trow();
		$xtdispportal_icon_cache = $cache->read('posticons');
		$query = $db->query('
			SELECT t.*, t.username AS tusername, u.username, u.avatar, u.usergroup, u.displaygroup
			FROM '.TABLE_PREFIX.'threads t
			LEFT JOIN '.TABLE_PREFIX.'users u ON (u.uid=t.uid)
			LEFT JOIN '.TABLE_PREFIX.'threadfields_data td ON (td.tid=t.tid)
			WHERE '.$xtdpf_fid_in.'t.visible=1 AND td.xtdispportal="Yes" AND t.closed NOT LIKE "moved|%"'.$xtdispportal_unviewwhere.'
			ORDER BY t.dateline desc
		');
		if($db->num_rows($query)){
			global $xtdispportal_threads, $theme, $mybb, $parser, $templates, $forum_cache;
			$xtdispportal_threads_num = my_number_format($db->num_rows($query));
			while($xtdispportal = $db->fetch_array($query)){
				$xtdispportal_date = my_date($mybb->settings['dateformat'], $xtdispportal['dateline']);
				$xtdispportal_time = my_date($mybb->settings['timeformat'], $xtdispportal['dateline']);
				$xtdispportal_thread_subject = htmlspecialchars_uni($parser->parse_badwords($xtdispportal['subject']));
				$xtdispportal_thread_link = get_thread_link($xtdispportal['tid']);
				$xtdispportal_forum_name = preg_replace('#&(?!\#[0-9]+;)#si', '&amp;', $forum_cache[$xtdispportal['fid']]['name']);
				$xtdispportal_forum_link = get_forum_link($xtdispportal['fid']);
				$xtdispportal_replies = my_number_format($xtdispportal['replies']);
				$xtdispportal_views = my_number_format($xtdispportal['views']);
				if($xtdispportal['postpreview']){
					$xtdispportal_postpreview = htmlspecialchars_uni($xtdispportal['postpreview']);
				}
				if($xtdispportal['icon'] > 0 && $xtdispportal_icon_cache[$xtdispportal['icon']]){
					$xtdispportal_thread_icon = $xtdispportal_icon_cache[$xtdispportal['icon']];
					$xtdispportal_thread_icon = '<img src="'.htmlspecialchars_uni($xtdispportal_thread_icon['path']).'" alt="" title="" />';
				}else{
					$xtdispportal_thread_icon = '';
				}
				if($xtdispportal['uid'] == 0){
					$xtdispportal_profile_link = htmlspecialchars_uni($xtdispportal['tusername']);
				}else{
					$xtdispportal_profile_link = build_profile_link(format_name(htmlspecialchars_uni($xtdispportal['username']), $xtdispportal['usergroup'], $xtdispportal['displaygroup']), $xtdispportal['uid']);
				}
				if($xtdispportal['avatar']){
					$xtdispportal_user_avatar = '<img src="'.htmlspecialchars_uni($xtdispportal['avatar']).'" alt="" title="" width="45" height="45" />';
				}
				eval('$xtdispportal_threads_thread .= "'.$templates->get('xtdispportal_threads_thread').'";');
				$altbg = alt_trow();
			}
			eval('$xtdispportal_threads = "'.$templates->get('xtdispportal_threads').'";');
		}
	}
}
?>